<template>
    <Table
        ref="orderTable"
        :tableParams="tableParams"
        :btnRole="[]"
        :right-btn="[]"
        isEmail
        @selectionChange="handleSelectionChange"
        isCurrentChange
        @currentChange="emailContent"
    >
        <template #left>
            <el-button @click='CompletelyDel("")'>删除</el-button>
            <el-button @click='CompletelyDel("complete")'>彻底删除</el-button>
            <!-- <el-button>拉黑</el-button> -->
            <el-button @click="exportMail" style="margin-right: 12px;">导出邮件</el-button>
            <el-dropdown @visible-change="visibleChange">
                <el-button>
                    移动到<el-icon class="el-icon--right">
                        <arrow-down v-if="!visible" />
                        <arrow-up v-else />
                    </el-icon>
                </el-button>
                <template #dropdown>
                    <el-dropdown-menu>
                    <el-dropdown-item @click="CompletelyDel('', '移动')">垃圾箱</el-dropdown-item>
                    </el-dropdown-menu>
                </template>
            </el-dropdown>
        </template>
    </Table>
</template>

<script setup lang="ts">
    import Table from '@/components/Table/index.vue'
    import { tableTypes } from '@/components/Table/types'
    import { listEmails,trashEmails,completelyDelEmails,markStar  } from '@/api/emails';
    import { EmailsVO, EmailsQuery } from '@/api/emails/types';
    import { Star,StarFilled } from "@element-plus/icons-vue"
    import SvgIcon from '@/components/SvgIcon/index.vue'
    const router = useRouter();
    const emits = defineEmits(['refresh', 'emailContent', 'delChange', 'exportMails', 'readChange'])
    const emailContent = (val: any) => {
        if(val) {
            emits('emailContent', val)
        }
    }

    const tableParams = reactive<tableTypes<EmailsQuery, EmailsVO>>({
        tableColumn: [
            {
                show: true,
                label: '收件人',
                prop: 'recipientName',
                sortable: false,
                render: ({column}: { column: EmailsVO }) => {
                    let name = []
                    let nameItem = []
                    let style = column.isRead == 1 ? '' : 'font-weight: bold;'
                    if(column.customerls && column.customerls.length != 0) {
                        column.customerls.map(item => {
                            if(item.isDelete) {
                                name.push(item.customerName + '（已删除）')
                                nameItem.push({
                                    style,
                                    class: '',
                                })
                            }else if(!item.isMyCustomer) {
                                name.push(item.customerName +
                                    `（${ item.ownerByName ? (item.ownerByName + '的客户') : (item.hasGarbageCustomer ? '无效客户' : '公海客户') }）`
                                )
                                nameItem.push({
                                    style,
                                    class: '',
                                })
                            }else{
                                name.push(item.customerName)
                                nameItem.push({
                                    style,
                                    class: 'link',
                                    onClick: async ($event) => {
                                        $event.stopPropagation()
                                        const { href } = router.resolve({
                                            path: '/customer/followPanel',
                                            query: {
                                                id: item.id,
                                                resourceType: item.customerForm
                                            }
                                        })
                                        window.open(href, '_blank')
                                    }
                                })
                            }
                        })
                    }else {
                        name.push(column.recipientName || column.recipient)
                        nameItem.push({
                            style,
                            class: '',
                        })
                    }
                    let nameHtml = []
                    for(let i = 0;i < name.length; i++) {
                        nameHtml.push(h(
                            'span',
                            nameItem[i],
                            name[i]
                        ))
                    }
                    return [
                        h('div',{style:'display:flex;align-items: center'},[
                            h(ElIcon, [
                                h(column.isStar?StarFilled:Star,{
                                    class:'star_icon',
                                    style:column.isStar?'color:#1874ff;':'',
                                    onClick: async ($event) => {
                                        $event.stopPropagation()
                                        setStar(column)
                                    }
                                })
                            ]),
                            h('div', { class: 'email_title' }, nameHtml)
                        ])
                    ]
                }
            },
            {
                show: true,
                label: '主题',
                prop: 'subject',
                sortable: false,
                render: ({column}: { column: EmailsVO }) => {
                    let query: any = { id: column.id, emailType: 'senting' }
                    if(column.customerls && column.customerls.length == 1) {
                        query.customerId = column.customerls[0].id
                        query.resourceType = column.customerls[0].customerForm
                    }
                    let annex = null
                    if(column.attachmentNum) {
                        annex = h(SvgIcon, { 'iconClass': 'email-annex', style: { 'margin-right': '2px', width: '16px', height: '16px' } })
                    }
                    return [
                        h('div', { style: { display: 'flex', 'align-items': 'center' } }, [
                            annex,
                            h('div', {
                                class: 'link',
                                onClick: async ($event) => {
                                    $event.stopPropagation()
                                    const { href } = router.resolve({
                                        path: '/customer/followPanel/detail',
                                        query
                                    })
                                    window.open(href, '_blank')
                                }
                            }, column.subject)
                        ])
                    ]
                }
            },
            { show: true, label: '日期', prop: 'sentDate', sortable: false },
            { show: true, label: '预计时间', prop: 'delaySendTime', sortable: false },
            { show: true, label: '大小', prop: 'emailSizeName', sortable: false},
            {
                show: true,
                label: '发送状态',
                prop: 'status',
                render: ({column}: { column: EmailsVO }) => {
                    let statusName = ''
                    if(column.status == -1) {
                        statusName = '待发送'
                    }else if(column.status == 0) {
                        statusName = '发送中'
                    }else if(column.status == 1) {
                        statusName = '发送成功'
                    }else if(column.status == 2) {
                        statusName = '发送失败'
                    }
                    return [
                        h('div', {}, statusName),
                    ]
                }
             },
            {
                show: true, label: '操作', width: 100, prop: 'operation', disabledMove: true, render: ({ column }: { column: EmailsVO }) => {
                    let recordFlag = false
                    let isDisabled = false
                    if(column.customerls && column.customerls.length != 0) {
                        if(column.customerls[0].isDelete) {
                            recordFlag = true
                        }
                    }else {
                        recordFlag = true
                    }
                    if(column.customerls && column.customerls.length > 1) {
                        isDisabled = true
                    }
                    return [
                        h(ElButton, {
                            link: true,
                            type: 'primary',
                            onClick:async($event)=>{
                                $event.stopPropagation()
                                const { href } = router.resolve({
                                    path: '/email/send',
                                    query: {
                                        id: column.id,
                                        type:'edit'
                                    }
                                })
                                window.open(href, '_blank')
                            }
                        }, '重发'),
                        // recordFlag ? [
                        //     h(ElButton, {
                        //         link: true,
                        //         type: !isDisabled?'primary':'info',
                        //         disabled: isDisabled,
                        //         onClick:async($event)=>{
                        //             $event.stopPropagation()
                        //             const { href } = router.resolve({
                        //                 path: '/customer/liaison/add',
                        //                 query: {
                        //                     type:'add',
                        //                     email: column.recipient
                        //                 }
                        //             })
                        //             window.open(href, '_blank')
                        //         }
                        //     }, '建联系人'),
                        //     h(ElButton, {
                        //         link: true,
                        //         type: !isDisabled?'primary':'info',
                        //         disabled: isDisabled,
                        //         onClick:async($event)=>{
                        //             $event.stopPropagation()
                        //             const { href } = router.resolve({
                        //                 path: '/clue/add',
                        //                 query: {
                        //                     type:'add',
                        //                     email: column.recipient
                        //                 }
                        //             })
                        //             window.open(href, '_blank')
                        //         }
                        //     }, '建线索'),
                        //     h(ElButton, {
                        //         link: true,
                        //         type: !isDisabled?'primary':'info',
                        //         disabled: isDisabled,
                        //         onClick:async($event)=>{
                        //             $event.stopPropagation()
                        //             const { href } = router.resolve({
                        //                 path: '/customer/addCustomer',
                        //                 query: {
                        //                     type:'add',
                        //                     email: column.recipient
                        //                 }
                        //             })
                        //             window.open(href, '_blank')
                        //         }
                        //     }, '建客户')
                        // ] : h(ElButton, {
                        //     link: true,
                        //     type: 'info',
                        //     disabled: true,
                        // }, '已建档')
                    ]
                }
            },
        ],
        queryParams: {
            boxCode:'SENTING',
            blurry: ''
        },
        listFn: listEmails
    })

    const { queryParams } = toRefs(tableParams)

    const ids = ref([])
    const single:any = ref(0)
    /** 多选框选中数据 */
    const handleSelectionChange = (selection: EmailsVO[]) => {
        ids.value = selection.map(item => item.id);
        single.value = selection.length;
    }

    const CompletelyDel = (val:string, text = '删除') =>{
        if(single.value == 0){
            ElMessage.error(`请选择需要${ text }的邮件`)
        }else{
            let tips = val==''?'':'彻底'
            ElMessageBox.confirm(
                '是否确认'+tips+ text + '当前邮件？',
                '确认提示',
                { type: 'warning', confirmButtonText: '提交' }
            ).then(() => {
                if(val==''){
                    let params = {
                        emailIds:ids.value,
                        isTrash:1,
                    }
                    trashEmails(params).then(res => {
                        if(res.success) {
                            ElMessage.success('邮件已移至垃圾箱')
                            handleQuery()
                        }
                    })
                }else{
                    completelyDelEmails(ids.value).then(res => {
                        if(res.success) {
                            ElMessage.success('邮件已删除成功')
                            handleQuery()
                        }
                    }).finally(() => {
                    })
                }

            }).catch(() => {})
        }
    }

    const setStar = (item:any) => {
        let params = {
            isStar:item.isStar?0:1,
            emailId:item.id,
        }
        markStar(params).then(res => {
            if(res.success) {
                handleQuery()
            }
        })
    }

    const exportMail = () => {
        emits('exportMails', ids.value)
    }

    /** 搜索操作 */
    const orderTable = ref()
    const handleQuery = () => {
        orderTable.value.getData()
    }

    const visible = ref(false)
    const visibleChange = (val: boolean) => {
        visible.value = val
    }

    defineExpose({
        handleQuery,
        queryParams
    })
</script>
